// JuliaFractalView.cpp : implementation of the CJuliaFractalView class
//

#include "stdafx.h"
#include "JuliaFractal.h"

#include "JuliaFractalDialog.h"
#include "JuliaFractalDoc.h"
#include "JuliaFractalView.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CJuliaFractalView

IMPLEMENT_DYNCREATE(CJuliaFractalView, CView)

BEGIN_MESSAGE_MAP(CJuliaFractalView, CView)
	//{{AFX_MSG_MAP(CJuliaFractalView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJuliaFractalView construction/destruction

CJuliaFractalView::CJuliaFractalView() 
{
	// TODO: add construction code here
	m_bCaptured=FALSE;
	//2(xmax-xmin)=3(ymax-ymin)
	xmin=-1.8;
	xmax=1.8;
	ymin=-1.2;
	ymax=1.2;

	xdots=640;
	ydots=480;

	px=0.36;
	py=0.1;

	itera=200;
	
	NoInfinito_n=0;
	NoInfinito.rojo=255;
	NoInfinito.verde=255;
	NoInfinito.azul=255;
   
	Rojo.rojo=128;
	Rojo.verde=0;
	Rojo.azul=0;
	Amarillo.rojo=0;
	Amarillo.verde=128;
	Amarillo.azul=0;
	Cyan.rojo=0;
	Cyan.verde=0;
	Cyan.azul=128;
	
	/*
	paleta Rojo	  ={ 63,  0,  0 };
	paleta Amarillo ={ 63, 63,  0 };
	paleta Cyan     ={  0, 63, 63 };
	*/

	pal_colores=256;
	pal_saturacion=0;

	pal->rojo=0;
	pal->verde=0;
	pal->azul=0;
	int i,n,m;

	n=85;
	m=0;
	for (i=1;i<=85;i++){
		(pal+i)->rojo=((i*Rojo.rojo+(86-i)*Amarillo.rojo)/n)+m;
		(pal+i)->verde=((i*Rojo.verde+(86-i)*Amarillo.verde)/n)+m;
		(pal+i)->azul=((i*Rojo.azul+(86-i)*Amarillo.azul)/n)+m;
		(pal+i+85)->rojo=((i*Cyan.rojo+(86-i)*Rojo.rojo)/n)+m;
		(pal+i+85)->verde=((i*Cyan.verde+(86-i)*Rojo.verde)/n)+m;
		(pal+i+85)->azul=((i*Cyan.azul+(86-i)*Rojo.azul)/n)+m;
		(pal+i+170)->rojo=((i*Amarillo.rojo+(86-i)*Cyan.rojo)/n)+m;
		(pal+i+170)->verde=((i*Amarillo.verde+(86-i)*Cyan.verde)/n)+m;
		(pal+i+170)->azul=((i*Amarillo.azul+(86-i)*Cyan.azul)/n)+m;	
	}
	//256 colores, de 0...255
}

CJuliaFractalView::~CJuliaFractalView()
{
}

BOOL CJuliaFractalView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	//return CView::PreCreateWindow(cs);

	if (!CView::PreCreateWindow(cs)){
		return FALSE;
	}
	//Para selecionar fondo del marco y cursor estandar
	cs.lpszClass=AfxRegisterWndClass(CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW,AfxGetApp()->LoadCursor(32501),::CreateSolidBrush(RGB(0,0,0)));
	if (cs.lpszClass != NULL){
		return TRUE;
	}
	else {
		return FALSE;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CJuliaFractalView drawing

void CJuliaFractalView::OnDraw(CDC* pDC)
{
	//CJuliaFractalDoc* pDoc = GetDocument();
	//ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	
	
	TRACE("CJuliaFractalView::OnDraw\n");
	TRACE("px=%f,py=%f\n",px,py);
	TRACE("xmin=%f,ymax=%f,xmax=%f,ymin=%f\n",xmin,ymax,xmax,ymin);

	if (m_bCaptured){
		//pDC->MoveTo(m_pointTopLeft);
		//pDC->LineTo(m_pointTopLeft.x,m_pointBottomRight.y);

		//pDC->Rectangle(xmin,ymax,xmax,ymin);
	}
	else {
		


/* Algoritmo de Julia de escape */
/* Graficos : xdots X ydots X colores */
	float pi,qi;
	unsigned r=10000;	//Infinito
	int p,q,k;
	float x,y,xx,yy;
	int aux,aux1;

	//ABSURDO
	if (pal_colores==256)
		aux1=10;
	else aux1=20;
	
	pi=(xmax-xmin)/(xdots);
	qi=(ymax-ymin)/(ydots);
	
	for(p=0;p<=xdots;p++) {
		for(q=0;q<=ydots;q++) {
			xx=xmin+p*pi;
			yy=ymin+q*qi;
			for(k=1;k<=itera;k++) {
				x=xx*xx-yy*yy+px;
				y=2*xx*yy+py;
				xx=x;
				yy=y;
				if(x*x+y*y>r) {
					//Represento los colores puntos que tienden al infinito
					//Los no representados(en blanco) no tienden a infinito
					//Cuanto menor sea k, mayor crecimiento tendr el punto hacia infinito
					aux=(aux1*k)%pal_colores;
					pDC->SetPixelV(p, q, RGB(pal[aux].rojo,pal[aux].verde,pal[aux].azul));
					break;
					}
				if(k==itera){
					pDC->SetPixelV(p, q, RGB(NoInfinito.rojo,NoInfinito.verde,NoInfinito.azul));
					break;
				}

				}
			}
		}	
//Paleta actual


	int n,m,pal_div;
	pal_div=pal_colores/2;
	for (n=0;n<=(pal_div-1);n++) {
		for (m=0;m<=10;m++) {
			pDC->SetPixelV(n,m, RGB((pal+n+pal_div)->rojo,(pal+n+pal_div)->verde,(pal+n+pal_div)->azul));
			pDC->SetPixelV(n,m+11, RGB((pal+n)->rojo,(pal+n)->verde,(pal+n)->azul));
			//pDC->SetPixelV(2*n+1,m, RGB((pal+n)->rojo,(pal+n)->verde,(pal+n)->azul));
			//pDC->SetPixelV(4*n+2,m, RGB((pal+n)->rojo,(pal+n)->verde,(pal+n)->azul));
			//pDC->SetPixelV(4*n+3,m, RGB((pal+n)->rojo,(pal+n)->verde,(pal+n)->azul));
		}
	}

}
}

/////////////////////////////////////////////////////////////////////////////
// CJuliaFractalView printing

BOOL CJuliaFractalView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CJuliaFractalView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CJuliaFractalView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CJuliaFractalView diagnostics

#ifdef _DEBUG
void CJuliaFractalView::AssertValid() const
{
	CView::AssertValid();
}

void CJuliaFractalView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CJuliaFractalDoc* CJuliaFractalView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CJuliaFractalDoc)));
	return (CJuliaFractalDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CJuliaFractalView message handlers

void CJuliaFractalView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	//CClientDC dc(this);
	//OnPrepareDC(&dc);
	
	CRect rectDevice;
	GetClientRect(rectDevice);
	
	if (rectDevice.PtInRect(point)) {
		SetCapture();
		
		m_bCaptured=TRUE;
		
		float pi,qi;
			
		pi=(float)(xmax-xmin)/rectDevice.Width();
		qi=(float)(ymax-ymin)/rectDevice.Height() ;
		
		//point coordenadas de dispositivo
		//centro en equina superior isquierda
		Zxmin=(float)xmin+(float)point.x*pi;
		Zymax=(float)ymax-(float)point.y*qi;
		Zxmax=(float)0;
		Zymin=(float)0;
		
		TRACE("CJuliaFractalView::OnLButtomDown\nx=%d,y=%d\n",point.x,point.y);
		TRACE("nizq=%d,arri=%d,der=%d,aba=%d\n",rectDevice.left,rectDevice.top,rectDevice.right,rectDevice.bottom);
		TRACE("xmin=%f,ymax=%f,xmax=%f,ymix=%f\n",xmin,ymax,xmax,ymin);
		TRACE("m_bCaptured TRUE\n");
		TRACE("ancho=%d,alto=%d\n",rectDevice.Width(),rectDevice.Height());
		TRACE("pi=%f,qi=%f\n",pi,qi);
		TRACE("Zxmin=%f,Zymax=%f\n",Zxmin,Zymax);
	
		
		//m_pointTopLeft=point;
		//m_pointBottomRight=point;

		
		::SetCursor(::LoadCursor(NULL,IDC_CROSS));
		
	}

  }

void CJuliaFractalView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	//pDC->SetMapMode(MM_HIMETRIC);
	//CView::OnPrepareDC(pDC, pInfo);//= la pongo

	CRect rectClient;

	GetClientRect(rectClient);
	pDC->SetMapMode(MM_ANISOTROPIC);
	pDC->SetWindowExt(xdots, ydots);
	pDC->SetViewportExt(rectClient.right, -rectClient.bottom);
	pDC->SetViewportOrg(0 ,rectClient.bottom );
	//Esquina inferior izquierda es el cero lgico
  }





void CJuliaFractalView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	//CView::OnLButtonUp(nFlags, point);

	if(m_bCaptured) {
		::ReleaseCapture();
		m_bCaptured=FALSE;

		CRect rectDevice;
		GetClientRect(rectDevice);

		float pi,qi;	
		pi=(float)(xmax-xmin)/rectDevice.Width();
		qi=(float)(ymax-ymin)/rectDevice.Height();
		
			
		Zxmax=(float)xmin+(float)point.x*pi;
		Zymin=(float)ymax-(float)point.y*qi;
		
		TRACE("CJuliaFractalView::OnLButttonUp\n");
		TRACE("ancho=%d,alto=%d\n",rectDevice.Width(),rectDevice.Height());
		TRACE("pi=%f,qi=%f\n",pi,qi);
		TRACE("Zxmax=%f,Zymin=%f\n",Zxmax,Zymin);

		float ancho,alto,centroX,centroY;
		
		ancho=Zxmax-Zxmin;
		alto=Zymax-Zymin;
		centroX=(ancho/2)+Zxmin;
		centroY=(alto/2)+Zymin;
		
		TRACE("ancho=%f,alto=%f,centroX=%f,centroY=%f",ancho,alto,centroX,centroY);


		xmin=centroX-(ancho/2);
		xmax=centroX+(ancho/2);
		//Ancho es la variable independiente
		//2*ancho=3*alto

		ymin=centroY-(ancho/3);
		ymax=centroY+(ancho/3);
	
		TRACE("xmin=%f,ymax=%f,xmax=%f,ymix=%f\n",xmin,ymax,xmax,ymin);
		InvalidateRect(rectDevice);

	}
	
}

void CJuliaFractalView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	//CView::OnMouseMove(nFlags, point);

if (m_bCaptured) {
		//CClientDC dc(this);
		//OnPrepareDC(&dc);

		//CRect rectOld(m_pointTopLeft,m_pointBottomRight);
		//InvalidateRect(rectOld,TRUE);
				
		//m_pointBottomRight=point;

		//CRect rectNew(m_pointTopLeft,m_pointBottomRight);
		//InvalidateRect(rectNew,TRUE);
	}

  }

void CJuliaFractalView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	//CView::OnRButtonDown(nFlags, point);
	CRect rectDevice;
	GetClientRect(rectDevice);
	
	if (rectDevice.PtInRect(point)) {

	CJuliaFractalDialog dlg;
	if (xdots==640)
		dlg.m_nRes=0;	//0=640x480,1=800x600,2=1024x768
	if (xdots==800)
		dlg.m_nRes=1;	//0=640x480,1=800x600,2=1024x768
	if (xdots==1024)
		dlg.m_nRes=2;	//0=640x480,1=800x600,2=1024x768
	dlg.m_fSpin1=px;
	dlg.m_fSpin2=py;
	dlg.m_fSpin3=1.0;
	dlg.Cx=px;
	dlg.Cy=py;
	dlg.m_bArreglar=FALSE;
	dlg.m_nTrackbar1=Rojo.rojo;
	dlg.m_nTrackbar2=Rojo.azul;
	dlg.m_nTrackbar3=Amarillo.rojo;
	dlg.m_nTrackbar4=Amarillo.verde;
	dlg.m_nTrackbar5=Cyan.verde;
	dlg.m_nTrackbar6=Cyan.azul;
	dlg.m_nTrackbar7=Rojo.verde;
	dlg.m_nTrackbar8=Amarillo.azul;
	dlg.m_nTrackbar9=Cyan.rojo;
	dlg.m_nTrackbar10=pal_saturacion;
	if (pal_colores==256)
		dlg.m_nColores=0;
	if (pal_colores==511)
		dlg.m_nColores=1;
	dlg.m_nConst=0;
	dlg.m_nNoInfinito=NoInfinito_n;
	
	int ret=dlg.DoModal();

	TRACE("DoModal return = %d\n",ret);
	TRACE("Resolucin= %d\n",dlg.m_nRes);
	TRACE("Cx= %f,Cy= %f,|C|= %f\n",dlg.m_fSpin1,dlg.m_fSpin2,dlg.m_fSpin3);

	if (ret==1){
		//Presion Aceptar o Enter
		if (dlg.m_nRes==0){
			xdots=640;
			ydots=480;
		}
		if (dlg.m_nRes==1){
			xdots=800;
			ydots=600;
		}
		if (dlg.m_nRes==2){
			xdots=1024;
			ydots=768;
		}
		if (dlg.m_bArreglar==TRUE){
			TRACE("arreglar = TRUE\n");
			TRACE("Mdulo= %f\n",dlg.m_fSpin3);
			//2<=raiz cuadrada(C1^2+C2^2)
			px=dlg.m_fSpin1;
			py=sqrt(dlg.m_fSpin3*dlg.m_fSpin3-dlg.m_fSpin1*dlg.m_fSpin1);

		}
		else{
			TRACE("arreglar = FALSE\n");
			px=dlg.m_fSpin1;
			py=dlg.m_fSpin2;
		}

		if (dlg.m_bCheckZoom==TRUE){
			xmin=-1.8;
			xmax=1.8;
			ymin=-1.2;
			ymax=1.2;
		}

		if (dlg.m_nNoInfinito==0){
			NoInfinito_n=0;
				NoInfinito.rojo=200;
				NoInfinito.verde=200;
				NoInfinito.azul=200;
		}
		if (dlg.m_nNoInfinito==1){
			NoInfinito_n=1;
				NoInfinito.rojo=50;
				NoInfinito.verde=50;
				NoInfinito.azul=50;
		}
		if (dlg.m_nNoInfinito==2){
			NoInfinito_n=2;
				NoInfinito.rojo=150;
				NoInfinito.verde=0;
				NoInfinito.azul=0;
		}
		if (dlg.m_nNoInfinito==3){
			NoInfinito_n=3;
				NoInfinito.rojo=0;
				NoInfinito.verde=150;
				NoInfinito.azul=0;
		}
		if (dlg.m_nNoInfinito==4){
			NoInfinito_n=4;
				NoInfinito.rojo=0;
				NoInfinito.verde=0;
				NoInfinito.azul=150;
		}


		if (dlg.m_bCheckConst==TRUE){
			if (dlg.m_nConst==0){
				px=0.36;
				py=0.1;
				}
			if (dlg.m_nConst==1){
				px=-1.5;
				py=0.0;
				}
			if (dlg.m_nConst==2){
				px=-0.8;
				py=0.4;
				}
			if (dlg.m_nConst==3){
				px=-0.92;
				py=0.3;
				}
			if (dlg.m_nConst==4){
				px=0.5;
				py=0.0;
				}
			if (dlg.m_nConst==5){
				px=-1.0;
				py=0.0;
				}
			if (dlg.m_nConst==6){
				px=0.35;
				py=0.08;
				}
			if (dlg.m_nConst==7){
				px=0.0;
				py=0.0;
				}

		}
		
		Rojo.rojo=dlg.m_nTrackbar1;
		Rojo.azul=dlg.m_nTrackbar2;
		Amarillo.rojo=dlg.m_nTrackbar3;
		Amarillo.verde=dlg.m_nTrackbar4;
		Cyan.verde=dlg.m_nTrackbar5;
		Cyan.azul=dlg.m_nTrackbar6;
		Rojo.verde=dlg.m_nTrackbar7;
		Amarillo.azul=dlg.m_nTrackbar8;
		Cyan.rojo=dlg.m_nTrackbar9;
		pal_saturacion=dlg.m_nTrackbar10;
		
	pal->rojo=0;
	pal->verde=0;
	pal->azul=0;
	int i,n;

		if (dlg.m_nColores==0){
			pal_colores=256;
			
			n=85;
			
			for (i=1;i<=n;i++){
				(pal+i)->rojo=((i*Rojo.rojo+(n+1-i)*Amarillo.rojo)/n)+pal_saturacion;
				(pal+i)->verde=((i*Rojo.verde+(n+1-i)*Amarillo.verde)/n)+pal_saturacion;
				(pal+i)->azul=((i*Rojo.azul+(n+1-i)*Amarillo.azul)/n)+pal_saturacion;
				(pal+i+n)->rojo=((i*Cyan.rojo+(n+1-i)*Rojo.rojo)/n)+pal_saturacion;
				(pal+i+n)->verde=((i*Cyan.verde+(n+1-i)*Rojo.verde)/n)+pal_saturacion;
				(pal+i+n)->azul=((i*Cyan.azul+(n+1-i)*Rojo.azul)/n)+pal_saturacion;
				(pal+i+2*n)->rojo=((i*Amarillo.rojo+(n+1-i)*Cyan.rojo)/n)+pal_saturacion;
				(pal+i+2*n)->verde=((i*Amarillo.verde+(n+1-i)*Cyan.verde)/n)+pal_saturacion;
				(pal+i+2*n)->azul=((i*Amarillo.azul+(n+1-i)*Cyan.azul)/n)+pal_saturacion;	
			}
			//256 colores, de 0...255
		}
		if (dlg.m_nColores==1){
			pal_colores=511;
			
			
			paleta Magenta,Amarillo2,Cyan2;

	Magenta.rojo=128;
	Magenta.verde=0;
	Magenta.azul=128;//
	Amarillo2.rojo=128;
	Amarillo2.verde=128;
	Amarillo2.azul=0;
	Cyan2.rojo=0;
	Cyan2.verde=128;
	Cyan2.azul=128;//
			n=85;
		
			for (i=1;i<=n;i++){
				(pal+i)->rojo=((i*Rojo.rojo+(n+1-i)*Amarillo2.rojo)/n)+pal_saturacion;
				(pal+i)->verde=((i*Rojo.verde+(n+1-i)*Amarillo2.verde)/n)+pal_saturacion;
				(pal+i)->azul=((i*Rojo.azul+(n+1-i)*Amarillo2.azul)/n)+pal_saturacion;

				(pal+i+n)->rojo=((i*Magenta.rojo+(n+1-i)*Rojo.rojo)/n)+pal_saturacion;
				(pal+i+n)->verde=((i*Magenta.verde+(n+1-i)*Rojo.verde)/n)+pal_saturacion;
				(pal+i+n)->azul=((i*Magenta.azul+(n+1-i)*Rojo.azul)/n)+pal_saturacion;

				(pal+i+2*n)->rojo=((i*Cyan.rojo+(n+1-i)*Magenta.rojo)/n)+pal_saturacion;
				(pal+i+2*n)->verde=((i*Cyan.verde+(n+1-i)*Magenta.verde)/n)+pal_saturacion;
				(pal+i+2*n)->azul=((i*Cyan.azul+(n+1-i)*Magenta.azul)/n)+pal_saturacion;
				
				(pal+i+3*n)->rojo=((i*Cyan2.rojo+(n+1-i)*Cyan.rojo)/n)+pal_saturacion;
				(pal+i+3*n)->verde=((i*Cyan2.verde+(n+1-i)*Cyan.verde)/n)+pal_saturacion;
				(pal+i+3*n)->azul=((i*Cyan2.azul+(n+1-i)*Cyan.azul)/n)+pal_saturacion;

				(pal+i+4*n)->rojo=((i*Amarillo.rojo+(n+1-i)*Cyan2.rojo)/n)+pal_saturacion;
				(pal+i+4*n)->verde=((i*Amarillo.verde+(n+1-i)*Cyan2.verde)/n)+pal_saturacion;
				(pal+i+4*n)->azul=((i*Amarillo.azul+(n+1-i)*Cyan2.azul)/n)+pal_saturacion;

				(pal+i+5*n)->rojo=((i*Amarillo2.rojo+(n+1-i)*Amarillo.rojo)/n)+pal_saturacion;
				(pal+i+5*n)->verde=((i*Amarillo2.verde+(n+1-i)*Amarillo.verde)/n)+pal_saturacion;
				(pal+i+5*n)->azul=((i*Amarillo2.azul+(n+1-i)*Amarillo.azul)/n)+pal_saturacion;

				
			}
		//511 colores, de 0...510
		}


		InvalidateRect(rectDevice);
	}
	
	}
}

void CJuliaFractalView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	
	CScrollView::OnInitialUpdate();
	CSize sizeTotal(800, 1050); // 8 por 10'5 pulgadas
	CSize sizePage(sizeTotal.cx / 2, sizeTotal.cy / 2);
	CSize sizeLine(sizeTotal.cx / 50, sizeTotal.cy / 50);
	SetScrollSizes(MM_LOENGLISH, sizeTotal, sizePage, sizeLine);
}
