// JuliaFractalView.h : interface of the CJuliaFractalView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_JULIAFRACTALVIEW_H__43975E6D_4830_11D3_BB39_CD99832F0D27__INCLUDED_)
#define AFX_JULIAFRACTALVIEW_H__43975E6D_4830_11D3_BB39_CD99832F0D27__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CJuliaFractalView : public CScrollView
{
protected: // create from serialization only
	CJuliaFractalView();
	DECLARE_DYNCREATE(CJuliaFractalView)

// Attributes
public:
	CJuliaFractalDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJuliaFractalView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	typedef struct PALETA {
	unsigned char rojo;
	unsigned char verde;
	unsigned char azul;
		} paleta;

	
	virtual ~CJuliaFractalView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CJuliaFractalView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


private:
	int itera;
	paleta pal[520];
	int pal_colores;
	int pal_saturacion;
	paleta Rojo;
	paleta Amarillo;
	paleta Cyan;
	paleta NoInfinito;

	int NoInfinito_n;

	int ydots;
	int xdots;
	
	float py;
	float px;
	
	BOOL m_bCaptured;
	
	//CPoint m_pointTopLeft,m_pointBottomRight;
	float xmin,xmax,ymin,ymax,Zxmin,Zxmax,Zymin,Zymax;
	


};

#ifndef _DEBUG  // debug version in JuliaFractalView.cpp
inline CJuliaFractalDoc* CJuliaFractalView::GetDocument()
   { return (CJuliaFractalDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JULIAFRACTALVIEW_H__43975E6D_4830_11D3_BB39_CD99832F0D27__INCLUDED_)
